#include "Autonome.h"
#include "ServicesSysteme.h" // PATCH
#include <windows.h>


namespace
{
   unsigned long __stdcall ThreadGenerique (void *p)
   {
      Autonome *pA = reinterpret_cast<Autonome *> (p);
      pA->LorsDuDemarrage ();
      while (!pA->GetArretDemande ())
      {
         pA->Suspendre ();
         if (!TesterFinDePartie ()) // PATCH!
            pA->Agir ();
      }
      pA->AvantDeTerminer ();
      pA->ArretComplet();
      return 0L;
   }
}

#include "Incopiable.h"

class ThreadRep
   : Incopiable
{
   HANDLE hth_;
public:
   ThreadRep (const HANDLE hTh)
      : hth_ (hTh)
   {
   }
   ~ThreadRep () throw ()
      { CloseHandle (hth_); }
};

Autonome::Autonome (const delai_t delai)
   : Rythmique (delai), rep_ (0)
{
}

bool Autonome::Demarrer ()
{
   if (rep_) return false; // viter les threads sauvages
   DWORD id;
   HANDLE hTh = CreateThread
      (0, 0, ::ThreadGenerique, this, CREATE_SUSPENDED, &id);
   if (hTh)
   {
      rep_ = new ThreadRep (hTh);
      ResumeThread (hTh);
   }
   return hTh != 0;
}

void Autonome::Arreter () throw()
{
   if (rep_)
   {
      DemandeArret ();
      AttendreArret ();
      delete rep_;
      // au cas o Arreter() ne serait pas invoqu par Autonome::~Autonome()
      rep_ = 0;
   }
}