#ifndef AVATAR_H
#define AVATAR_H

#include "PtrPartage.h"
#include "Deplacable.h"
#include "AbonneDeplacable.h"
#include "AutoriteDeplacement.h"
#include "Liberateur.h"
#include <string>
using std::string;

class Avatar
   : Deplacable, public AbonneDeplacable
{
public:
   typedef Deplacable::point_t point_t; // lever une ambiguit
private:
   class Impl;
   static Impl *Creer (const string &nom, const point_t &pos, Avatar *);
   void Mouvement (const Positionnable *p, const point_t)
      { positionner (p->position ()); }
   static void Liberer (const Impl *) throw ();
   friend struct Liberateur<Avatar>;
   PtrPartage<Impl, Liberateur<Avatar> > pimpl_;
protected:
   void deplacerImpl (const point_t &);
public:
   Avatar (const string &nom, const point_t &pos = point_t ())
      : Deplacable (pos), pimpl_(0)
   {
      pimpl_ = Creer (nom, pos, this); // hum...
   }
   ~Avatar () throw();
   const string & nom () const throw ();
   void NoterHurlement (const point_t &);
   //
   // Permettre la compilation; seules les versions pour
   // lesquelles il existera une dfinition pourront tre
   // lies, toutefois
   //
   template <class D>
      D * to_() const throw ();
};

#endif