#ifndef BOITE_H
#define BOITE_H

#include "locale_helper.h"
#include <string>
using std::basic_string;
using std::char_traits;
#include <vector>
using std::vector;
#include <memory>
using std::allocator;
#include <utility>
using std::max;
#include <iosfwd>
using std::ostream;
using std::endl;
//#include <locale>
//using std::locale;
//using std::use_facet;
//using std::ctype;

template <
      class CType,
      class Conteneur =
         vector<
            basic_string<CType>,
            allocator<basic_string<CType> >
         >
   >
   class Boite
   {
   public:
      typedef Conteneur conteneur_t;
      typedef CType value_type;
      typedef basic_string<value_type> str_type;
      typedef typename
         conteneur_t::size_type size_type;
   private:
      conteneur_t & conteneur_;
      size_type largeur_, hauteur_;
   public:
      Boite (conteneur_t &c)
         : conteneur_ (c), largeur_ (0), hauteur_ (0)
      {
         typedef typename
            conteneur_t::iterator iterator;
         for (iterator itt = conteneur_.begin (); itt != conteneur_.end (); ++itt)
         {
            ++hauteur_;
            largeur_ = max (largeur_, itt->size ());
         }
      }
      friend ostream &
         operator << (ostream &os, const Boite &b)
      {
         static const value_type
            COIN = char_convert<value_type>('+'),
            MUR_VERTICAL = char_convert<value_type>('|'),
            MUR_HORIZONTAL = char_convert<value_type>('-');
         os << COIN << str_type (b.largeur_, MUR_HORIZONTAL)
            << COIN << endl;
         typedef typename
            conteneur_t::iterator iterator;
         for (iterator itt = b.conteneur_.begin (); itt != b.conteneur_.end (); ++itt)
            os << MUR_VERTICAL << *itt << MUR_VERTICAL << endl;
         os << COIN << str_type (b.largeur_, MUR_HORIZONTAL)
            << COIN << endl;
         return os;
      }
   };
template <class CType, class Conteneur>
   Boite<CType, Conteneur> creerBoite (Conteneur &cont)
      { return Boite<CType, Conteneur> (cont); }

#endif
