#ifndef CATALOGUES_H
#define CATALOGUES_H

#include "Incopiable.h"
#include "Catalogue.h"
#include "Monstre.h"
#include "SingletonWrapper.h"
#include "type_list.h"
#include <vector>
using std::vector;
#include <string>
using std::string;
#include <iterator>
using std::distance;

class Avatar;
class Monstre;
class Tresor;

class Catalogues
   : Incopiable
{
public:
   typedef char symbol_type;
   typedef Catalogue<symbol_type> catalog_type;
private:
   typedef type_list<
      Avatar, type_list<
         Monstre, type_list<
            Tresor, Vide
         >
      >
   > liste_catalogues;
   enum { NB_CATALOGUES = longueur_liste<liste_catalogues>::VAL };
   template <class T>
      struct catalog_index
      {
         enum { VAL = position_dans_liste <liste_catalogues, T>::VAL };
      };
   catalog_type cat_[NB_CATALOGUES];
   vector<Monstre::mode_deplacement_t> modes_deplacements_;
   friend struct SingletonWrapper<Catalogues>;
   Catalogues () throw()
      { }
public:
   struct PatchMonstres
   {
      typedef Monstre::mode_deplacement_t mode_deplacement_t;
      string nom_;
      Monstre::mode_deplacement_t mode_;
      PatchMonstres (const string &nom, const mode_deplacement_t mode)
         : nom_(nom), mode_(mode)
      {
      }
   };
#pragma warning (disable : 4101)
   template <class T>
      catalog_type &catalogue () throw()
      {
         static_assert<position_dans_liste <liste_catalogues, T>::VAL >= 0>
            LeTypeDoitEtreDansLaListeDeCatalogues;
         return cat_[catalog_index<T>::VAL];
      }
#pragma warning (default : 4101)
   PatchMonstres TrouverMonstre (const symbol_type sym)
   {
      catalog_type::iterator itt = catalogue<Monstre>().trouver (sym);
      return PatchMonstres
         (itt->nom_, modes_deplacements_[distance (catalogue<Monstre>().begin(), itt)]);
   }
   ~Catalogues () throw()
      { }
   //
   // Ne compile que si catalog_index<T> est un type complet
   //
   template <class T>
      void Ajouter (const catalog_type::Element &e)
         { cat_[catalog_index<T>::VAL].push_back (e); }
   template <class T>
      void Ajouter (const catalog_type::Element &e, const Monstre::mode_deplacement_t mode)
      {
         cat_[catalog_index<T>::VAL].push_back (e);
         modes_deplacements_.push_back (mode);
      }
};

template <class T>
   Catalogues::catalog_type & ObtenirCatalogue ()
      { return ObtenirSingleton<Catalogues>().catalogue<T> (); }

#endif
