#ifndef CONTENEUR_SINGLETON_H
#define CONTENEUR_SINGLETON_H

#include "type_list.h"
#include "SingletonWrapper.h"

template <class TList>
   class ConteneurSingleton;

template <>
   class ConteneurSingleton<Vide>
   {
   public:
      Vide & Get () throw()
      {
         static Vide v;
         return v;
      }
   };

template <class Tete, class Queue>
   class ConteneurSingleton <type_list<Tete, Queue> >
      : public ConteneurSingleton<Queue>
   {
   public:
      typedef Tete singleton_t;
   private:
      SingletonWrapper<singleton_t> singleton_;
      template <class T>
         T & RecursiveParentGet () throw()
            { return ConteneurSingleton<Queue>::Get<T>(); }
   public:
      template <class T>
         T & Get () throw()
            { return RecursiveParentGet<T>(); }
      template <>
         singleton_t & Get <singleton_t> () throw()
            { return singleton_.Get (); }
   };

#endif
