#include "Deplacable.h"
#include "AbonneDeplacable.h"
#include "AutoriteDeplacement.h"

#include <algorithm>
using std::for_each;
using std::find_if;

bool AutoriserDeplacement
   (const ServiceAbonnement<AutoriteDeplacement> *srv,
    const Positionnable *p, const Positionnable::point_t &dest)
{
   typedef Positionnable::point_t point_t;
   class RefuseDeplacement
   {
      const Positionnable *acteur_;
      point_t apres_;
   public:
      RefuseDeplacement (const Positionnable *p, const point_t & apres)
         : acteur_(p), apres_ (apres)
      {
      }
      bool operator() (AutoriteDeplacement *p)
         { return ! p->AutoriserMouvement(acteur_, apres_); }
   };
   return find_if (srv->begin (), srv->end (), RefuseDeplacement (p, dest)) == srv->end ();
}

void PubliciserDeplacement
   (const ServiceAbonnement<AbonneDeplacable> *srv, Positionnable *acteur,
    const Positionnable::point_t &avant, const Positionnable::point_t &apres)
{
   typedef Positionnable::point_t point_t;
   class InformerDeplacement
   {
      point_t avant_, apres_;
      Positionnable *acteur_;
   public:
      InformerDeplacement(Positionnable *p, const point_t &avant, const point_t &apres)
         : acteur_(p), avant_(avant), apres_(apres)
      {
      }
      void operator () (AbonneDeplacable *p)
         { p->Mouvement (acteur_, avant_); }
   };
   for_each (srv->begin (), srv->end (), InformerDeplacement (acteur, avant, apres));
}

bool Deplacable::deplacer (const point_t &pos)
{
   Autoverrou av(mutex_);
   // patch! (debut)
   if (ServiceAbonnement<AbonneDeplacable>::size () < 2) return false; // le donjon et l'enveloppe
   // patch! (fin)
   //
   // ICI: se souvenir de la raison pour laquelle il est IMPORTANT
   // que AVANT et APRES soient des copies, pas des rfrences
   //
   const point_t AVANT = position ();
   if (!AutoriserDeplacement (this, this, pos)) return false;
   deplacerImpl (pos);
   const point_t APRES = position ();
   PubliciserDeplacement (this, this, AVANT, APRES);
   return true;
}
