#ifndef DEPLACABLE_H
#define DEPLACABLE_H

#include "Positionnable.h"
#include "Mutex.h"
#include "ServiceAbonnement.h"
#include <vector>
using std::vector;
#include <algorithm>
using std::remove;

struct AbonneDeplacable;
struct AutoriteDeplacement;

class Deplacable
   : public Positionnable,
     public ServiceAbonnement<AbonneDeplacable>,
     public ServiceAbonnement<AutoriteDeplacement>
{
   Mutex mutex_;
protected:
   virtual void deplacerImpl (const point_t &Pos)
      { positionner (Pos); }
public:
   using ServiceAbonnement<AbonneDeplacable>::Abonner;
   using ServiceAbonnement<AutoriteDeplacement>::Abonner;
   using ServiceAbonnement<AbonneDeplacable>::Desabonner;
   using ServiceAbonnement<AutoriteDeplacement>::Desabonner;
   Deplacable (const point_t &pos = point_t ()) throw ()
      : Positionnable (pos)
   {
   }
   bool deplacer (const point_t &);
};

#endif
