#ifndef DONJON_H
#define DONJON_H

#include "Affichable.h"
#include "AbonneDeplacable.h"
#include "AutoriteDeplacement.h"
#include "Catalogue.h"
#include "Point2D.h"
#include "PositionTraits.h"
#include "SectionCritique.h"

class CarteInexistante {};
class CarteVide {};
class CarteInvalide {};

class Deplacable;

#include "Catalogues.h"
#include "Carte.h"
#include "Dimension.h"
#include <vector>
using std::vector;
#include <string>
using std::basic_string;
#include <iosfwd>
using std::basic_ostream;

#pragma warning (disable : 4290)

class Donjon
   : public Affichable<position_traits::coord_t>,
     public AbonneDeplacable, public AutoriteDeplacement
{
public:
   typedef position_traits::point_t point_t;
   typedef Catalogues::symbol_type CType;
   typedef basic_string<CType> str_type;
private:
   SectionCritique critsect_;
   static const str_type CARTE_DEFAUT;
   void ConsommerCarte (const vector<str_type> &)
      throw (CarteInvalide, CarteVide);
   vector<Deplacable *> deplacables_;
   str_type ConsommerLigneCarte
      (const str_type &, const vector<str_type>::size_type);
   bool ConsommerLigneLegende (const str_type &) throw (CarteInvalide);
   void Mouvement (const Positionnable *, const point_t Avant);
   bool AutoriserMouvement (const Positionnable *, const point_t &Apres);
   void MouvementHeros
      (const str_type &, const point_t & avant, const point_t & apres);
   void MouvementMonstre
      (const str_type &, const point_t & avant, const point_t & apres);
   bool TrouverActeur (const Positionnable *) const throw ();
public:
   Donjon (const str_type &nomCarte = CARTE_DEFAUT)
      throw (CarteInexistante, CarteVide, CarteInvalide);
   basic_ostream<CType> &projeter
      (basic_ostream<CType> &, const Dimension<coord_t> &) const;
   ~Donjon () throw();
};

#pragma warning (default : 4290)

#endif