#include "Evenement.h"
#include <windows.h>

IEvenement::~IEvenement () throw()
   { }

class EvenementWin32
   : public IEvenement
{
   HANDLE evenement_;
public:
   EvenementWin32 (IEvenement::ReinitialisationAutomatique)
      : evenement_ (CreateEvent (0, FALSE, FALSE, 0))
   {
   }
   EvenementWin32 (IEvenement::ReinitialisationManuelle)
      : evenement_ (CreateEvent (0, TRUE, FALSE, 0))
   {
   }
   ~EvenementWin32 () throw ()
      { CloseHandle (evenement_); }
   bool Attendre () const volatile
      { return Attendre (INFINITE); }
   bool Attendre (const int ms) const volatile
      { return ::WaitForSingleObject (evenement_, ms) == WAIT_OBJECT_0; }
   void Provoquer () const volatile
      { ::SetEvent (evenement_); }
   void Reinitialiser () const volatile
      { ::ResetEvent (evenement_); }
};

const volatile IEvenement *IEvenement::Creer
   (IEvenement::ReinitialisationAutomatique categ)
      { return new EvenementWin32 (categ); }
const volatile IEvenement *IEvenement::Creer
   (IEvenement::ReinitialisationManuelle categ)
      { return new EvenementWin32 (categ); }
void IEvenement::Liberer (const volatile IEvenement *ie) throw ()
   { delete ie; }