#ifndef FORMATEUR_H
#define FORMATEUR_H

#include <string>
using std::basic_string;
#include <utility>
using std::min;

//
// Foncteur capable d'appliquer un formatage sur un texte
//
template <class CType, class Coord>
   class Formateur
   {
   public:
      typedef Coord coord_t;
      typedef CType value_type;
      typedef basic_string<value_type> str_type;
      typedef typename str_type::size_type size_type;
   private:
      coord_t largeur_;
      value_type fillchar_;
   public:
      Formateur (const coord_t largeur,
                 const value_type fillc = static_cast<value_type>(' '))
         : largeur_ (largeur), fillchar_ (fillc)
      {
      }
      str_type operator () (const str_type &s)
      {
         const size_type lar = largeur_;
         const size_type choplen = min (lar, s.length ());
         return
            s.substr (0, choplen) +
            str_type (choplen < lar ? lar - choplen : 0, fillchar_);
      }
   };
template <class CType, class Coord>
   Formateur<CType, Coord> creerFormateur
      (const Coord Largeur, const CType fillc = static_cast<CType>(' '))
   {
      return Formateur<CType, Coord> (Largeur, fillc);
   }


#endif
