#ifndef MONSTRE_H
#define MONSTRE_H

#include "PtrPartage.h"
#include "Deplacable.h"
#include "AbonneDeplacable.h"
#include "Liberateur.h"
#include <string>
using std::string;

class Monstre
   : Deplacable, public AbonneDeplacable
{
public:
   typedef Deplacable::point_t point_t; // lever une ambiguit
   typedef int mode_deplacement_t;
private:
   class Impl;
   static Impl *Creer
      (const string &, const point_t &, const mode_deplacement_t, Monstre *);
   void Mouvement (const Positionnable *p, const point_t)
      { positionner (p->position ()); }
   static void Liberer (const Impl *) throw ();
   friend struct Liberateur<Monstre>;
   PtrPartage<Impl, Liberateur<Monstre> > pimpl_;
protected:
   void deplacerImpl (const point_t &);
public:
   Monstre (const string &nom, const point_t &pos = point_t (), mode_deplacement_t mode= 0)
      : Deplacable (pos), pimpl_ (0)
   {
      pimpl_ = Creer (nom, pos, mode, this); // hum
   }
   ~Monstre () throw();
   //
   // Permettre la compilation; seules les versions pour
   // lesquelles il existera une dfinition pourront tre
   // lies, toutefois
   //
   template <class D>
      D * to_() const throw ();
   const string & nom () const throw ();
};

#endif