#include "Mutex.h"
#include <windows.h>

IMutex::~IMutex () throw()
   { }

class MutexWin32
   : public IMutex
{
   HANDLE mutex_;
public:
   MutexWin32 ()
      : mutex_ (CreateMutex (0, FALSE, 0))
   {
   }
   ~MutexWin32 () throw()
      { CloseHandle (mutex_); }
   bool Obtenir () const volatile
      { return Obtenir (INFINITE); }
   bool Obtenir (const int ms) const volatile
      { return WaitForSingleObject (mutex_, ms) == WAIT_OBJECT_0; }
   void Relacher () const volatile
      { ::ReleaseMutex (mutex_); }
};

const volatile IMutex *IMutex::Creer ()
   { return new MutexWin32; }
void IMutex::Liberer (const volatile IMutex *im) throw()
   { delete im; }
