#ifndef MUTEX_H
#define MUTEX_H

//
// retoucher l'article sur les mutex portables de h-deb
//
class IMutex
{
public:
   virtual bool Obtenir () const volatile = 0;
   virtual bool Obtenir (const int Ms) const volatile = 0;
   virtual void Relacher () const volatile = 0;
   static const volatile IMutex *Creer ();
   static void Liberer (const volatile IMutex *) throw();
protected:
   virtual ~IMutex () throw() = 0;
};

class Mutex
{
   const volatile IMutex *mutex_;
public:
   Mutex ()
       : mutex_ (IMutex::Creer())
   {
   }
   ~Mutex () throw()
      { IMutex::Liberer(mutex_); }
   bool Obtenir () const volatile
      { return mutex_->Obtenir(); }
   bool Obtenir (const int ms) const volatile
      { return mutex_->Obtenir(ms); }
   void Relacher () const volatile
      { mutex_->Relacher(); }
};

class Autoverrou
{
   const volatile Mutex &mutex_;
public:
   Autoverrou (const volatile Mutex &m)
      : mutex_ (m)
   {
      mutex_.Obtenir ();
   }
   ~Autoverrou () throw()
      { mutex_.Relacher (); }
};

#endif