#ifndef PARTIE_H
#define PARTIE_H

#include "Incopiable.h"
#include "Evenement.h"
#include "SingletonWrapper.h"
#include <fstream>
using std::ofstream;
#include <string>
using std::string;

class Partie
   : Incopiable
{
   ofstream journal_;
   Evenement fin_;
public:
   enum resultat_t
   {
      ERREUR_INITIALISATION, ERREUR_EXECUTION,
      INCONNU,
      TRESOR_TROUVE, AVATAR_DEVORE,
      RESULTAT_MIN = ERREUR_INITIALISATION,
      RESULTAT_MAX = AVATAR_DEVORE
   };
private:
   resultat_t resultat_;
   Partie ()
      : fin_ (Evenement::ReinitialisationManuelle ()),
        journal_ ("journal.txt"),
        resultat_(INCONNU)
   {
   }
   friend struct SingletonWrapper<Partie>;
public:
   ~Partie () throw()
      { }
   void ProvoquerFin (const resultat_t resultat) volatile
      { resultat_ = resultat; fin_.Provoquer (); }
   void AttendreFin () const volatile
      { fin_.Attendre (); }
   bool AttendreFin (const int ms) const volatile
      { return fin_.Attendre (ms); }
   void DemarrerJournal ();
   void TerminerJournal ();
   const string & DiagnosticFin () const throw();
};


#endif
