#ifndef POINT_2D_H
#define POINT_2D_H

#include <iosfwd>
using std::ostream;
#include <cmath>
using std::abs;

//
// vident en soi
//
template <class Coord>
   struct Point2D
   {
      typedef Coord coord_t;
      coord_t X, Y;
      Point2D (coord_t _X = coord_t (), coord_t _Y = coord_t ())
         : X (_X), Y(_Y)
      {
      }
      friend bool operator== (const Point2D &p0, const Point2D &p1)
         { return p0.X == p1.X && p0.Y == p1.Y; }
      friend bool operator!= (const Point2D &p0, const Point2D &p1)
         { return ! (p0 == p1); }
      friend int operator- (const Point2D &p0, const Point2D &p1)
         { return abs (p0.X - p1.X) + abs (p0.Y - p1.Y); }
   };

template <class T>
   ostream & operator<< (ostream & os, const Point2D<T> &pt)
      { return os << pt.X << "," << pt.Y; }

#endif
