#ifndef SECTION_CRITIQUE_H
#define SECTION_CRITIQUE_H

#include "Incopiable.h"
#include "ISectionCritique.h"

class SectionCritique
   : Incopiable
{
   const volatile ISectionCritique *m_pSectCrit;
   friend class Pogneur;
   void Entrer () const volatile
      { m_pSectCrit->Entrer (); }
   void Quitter () const volatile
      { m_pSectCrit->Quitter (); }
public:
   class Pogneur
   {
       const volatile SectionCritique &m_Sect;
   public:
      Pogneur (const volatile SectionCritique &sect)
         : m_Sect (sect)
      {
        m_Sect.Entrer ();
      }
      ~Pogneur ()
         { m_Sect.Quitter (); }
   };
   SectionCritique ()
      : m_pSectCrit (0)
   {
      m_pSectCrit = ISectionCritique::Creer ();
   }
   ~SectionCritique ()
      { ISectionCritique::Liberer (m_pSectCrit); }
};

#endif