#include "ServicesSysteme.h"
#include "VueEspace.h"
#include "PositionTraits.h"
#include "Evenement.h"
#include "Partie.h"
#include "Singletons.h"
#include "SingletonsOrdonnes.h"
#include "Catalogues.h"
#include <iostream>
using std::clog;
using std::endl;
#include <string>
using std::string;

void DemarrerJournal ()
   { ObtenirSingleton<Partie>().DemarrerJournal (); }
void TerminerJournal ()
   { ObtenirSingleton<Partie>().TerminerJournal (); }

void AttendreFinDePartie ()
   { ObtenirSingleton<Partie>().AttendreFin (); }
bool TesterFinDePartie ()
   { return ObtenirSingleton<Partie>().AttendreFin (0); }
void ProvoquerFinDePartie (int resultat)
   { ObtenirSingleton<Partie>().ProvoquerFin (static_cast<Partie::resultat_t>(resultat)); }


Zone<VueEspace<position_traits::coord_t> > & Messages ()
   { return ObtenirSingleton<VueEspace<position_traits::coord_t> >().ZoneMessages (); }

void EmettreMessage (const string &message)
{
   if (!message.empty ())
   {
      Messages () << message << endl;
      clog << message << endl;
   }
}

void DecrireResultats ()
{
   static const string PREFIXE = "Fin de la partie. Cause: ";
   EmettreMessage (PREFIXE + ObtenirSingleton<Partie>().DiagnosticFin ());
}

bool NbHerosValide ()
   { return ObtenirCatalogue<Avatar> ().size () == 1; }

#include "Temps.h"

Temps<Milliseconde> RythmeAvatarNormal()
   { return 1000; }
//   { return 1000; }
Temps<Milliseconde> RythmeAvatarRush()
   { return RythmeAvatarNormal ().value () / 4; }
Temps<Milliseconde> RythmeMonstreNormal()
   { return RythmeAvatarNormal ().value () / 2; }
Temps<Milliseconde> RythmeAffichage()
   { return 100; }

