#ifndef TRANSIT_TEXTE_H
#define TRANSIT_TEXTE_H

#include "Mutex.h"
#include <string>
using std::basic_string;

//
// Zone de transit scurise pour du texte
//
template <class CType>
   class TransitTexte
   {
   public:
      typedef basic_string<CType> str_type;
   private:
      str_type cur_;
      Mutex verrou_;
   public:
      void Ajouter (const str_type &s)
         { cur_ += s; }
      void Ajouter (const str_type &s) volatile
      {
         Autoverrou av (verrou_);
         const_cast<TransitTexte *> (this)->Ajouter (s);
      }
      str_type Consulter () const
         { return cur_; }
      str_type Consulter () const volatile
      {
         Autoverrou av (verrou_);
         return const_cast<TransitTexte *> (this)->Consulter ();
      }
      str_type Extraire ()
      {
         str_type temp = Consulter ();
         cur_.clear ();
         return temp;
      }
      str_type Extraire () volatile
      {
         Autoverrou av (verrou_);
         return const_cast<TransitTexte *> (this)->Extraire ();
      }
   };

#endif
