#include "TresorsSublimes.h"
#include "PartieEtudiante.h"
#include "Positionnable.h"
#include <vector>
using std::vector;
#include <algorithm>
using std::find;
using std::find_if;
using std::for_each;
#include <utility>
using std::min;

Tresor * TresorsSublimes::Identifier (const point_t &pos)
{
   vector<Tresor *>::iterator itt =
      find_if (tresors_.begin (), tresors_.end (), MemePosition (pos));
   return itt != tresors_.end ()? *itt : 0;
}

Tresor * TresorsSublimes::Identifier (const Positionnable *p)
   { return Identifier (p->position()); }

BoussoleMagique CreerBoussole (const int dist, const Direction dir)
{
   BoussoleMagique boussole;
   boussole.distance_ = dist;
   boussole.orientation_ = dir;
   return boussole;
}

#include <limits>
using std::numeric_limits;
BoussoleMagique TresorsSublimes::DistancePlusProcheDe
   (const point_t &pos)
{
   class PlusPetiteDistance
   {
      point_t pos_;
      BoussoleMagique valeur_;
   public:
      PlusPetiteDistance (const point_t &pos)
         : valeur_(CreerBoussole (numeric_limits<coord_t>::max (), Nord)), pos_(pos)
      {
      }
      Direction meilleureOrientation (const point_t &de, const point_t &vers)
      {
         const coord_t DX = de.X - vers.X;
         const coord_t DY = de.Y - vers.Y;
         coord_t nbPasHorizontaux = abs (DX);
         coord_t nbPasVerticaux   = abs (DY);
         Direction dir;
         if (nbPasHorizontaux == 0) // dj enlign  la verticale
            dir = (DY < 0)? Sud : Nord;
         else if (nbPasVerticaux == 0) // dj enlign  l'horizontale
            dir = (DX < 0)? Est : Ouest;
         else if (nbPasVerticaux > nbPasHorizontaux) // se rapprocher  la verticale
            dir = (DY < 0)? Sud : Nord;
         else // se rapprocher  l'horizontale
            dir = (DX < 0)? Est : Ouest;
         return dir;
      }
      void operator() (const Tresor *p)
      {
         int dist = pos_ - p->position ();
         if (dist < valeur_.distance_)
            valeur_ = CreerBoussole (dist, meilleureOrientation (pos_, p->position ()));
      }
      BoussoleMagique valeur () const throw()
         { return valeur_; }
   };
   return for_each (tresors_.begin (), tresors_.end (),
                    PlusPetiteDistance (pos)).valeur();
}
