#ifndef TRESORS_SUBLIMES_H
#define TRESORS_SUBLIMES_H

#include "Incopiable.h"
#include "Tresor.h"
#include "PtrPartage.h"
#include "SingletonWrapper.h"
#include <vector>
using std::vector;
#include <algorithm>
using std::for_each;

struct BoussoleMagique;
class Positionnable;

class TresorsSublimes
   : Incopiable
{
   friend struct SingletonWrapper<TresorsSublimes>;
   TresorsSublimes () throw()
      { }
   vector<Tresor *> tresors_;
public:
   typedef position_traits::point_t point_t;
   ~TresorsSublimes () throw()
      { for_each (tresors_.begin (), tresors_.end (), Detruire()); }
   void Ajouter (Tresor *p)
      { if (p) tresors_.push_back (p); }
   Tresor * Identifier (const point_t &);
   Tresor * Identifier (const Positionnable *);
   BoussoleMagique DistancePlusProcheDe (const point_t &);
};

#endif
