#ifndef VUE_ESPACE_H
#define VUE_ESPACE_H

#include "Zone.h"
#include "Incopiable.h"
#include "PositionTraits.h"
#include "SingletonWrapper.h"
#include <utility>
using std::make_pair;
#include <vector>
using std::vector;

template <class Coord = position_traits::coord_t>
   class VueEspace
      : Incopiable
   {
   public:
      typedef Coord coord_t;
      typedef typename
         base_position_traits<coord_t>::point_t point_t;
      typedef Zone<VueEspace<coord_t> > zone_type;
   private:
      zone_type jeu_;
      zone_type messages_;
      typedef std::pair<zone_type*, point_t> zone_t;
      vector<zone_t> zones_;
      friend struct SingletonWrapper<VueEspace>;
      enum
      {
         JEU_LARGEUR = 76,  JEU_HAUTEUR = 15,
         MSG_LARGEUR = 76,  MSG_HAUTEUR =  4,
         JEU_ANCRAGE_X = 1, JEU_ANCRAGE_Y = 1,
         MSG_ANCRAGE_X = 1,
         // 2 + 1 == bordures du jeu + une bordure de msg
         MSG_ANCRAGE_Y = JEU_ANCRAGE_Y + 2 + 1 + JEU_HAUTEUR
      };
      VueEspace ()
         : jeu_ (JEU_LARGEUR, JEU_HAUTEUR),
           messages_ (MSG_LARGEUR, MSG_HAUTEUR)
      {
         zones_.push_back
            (make_pair (&jeu_, point_t(JEU_ANCRAGE_X, JEU_ANCRAGE_Y)));
         zones_.push_back
            (make_pair (&messages_, point_t(MSG_ANCRAGE_X, MSG_ANCRAGE_Y)));
      }
   public:
      zone_type &ZoneMessages () throw()
         { return messages_; }
      zone_type &ZoneJeu () throw()
         { return jeu_; }
   };

#endif