#ifndef ZONE_H
#define ZONE_H

#include "Mutex.h"
#include "lexical_cast.h"
#include "Boite.h"
#include "Formateur.h"
#include "TransitTexte.h"
#include "Dimension.h"
#include <deque>
using std::deque;
#include <string>
using std::basic_string;
using std::string;
#include <vector>
using std::vector;
#include <algorithm>
using std::transform;
#include <iosfwd>
using std::ostream;
using std::endl;
#include <locale>
using std::ctype;
using std::use_facet;

template <class Referentiel>
   class Zone
   {
   public:
      typedef typename
         Referentiel::coord_t coord_t;
   private:
      Dimension<coord_t> dim_;
      deque<string> fenetre_;
      Mutex verrou_;
      volatile TransitTexte<char> cur_;
   public:
      Zone (const coord_t largeur, const coord_t hauteur)
         : dim_(largeur, hauteur)
      {
      }
      const Dimension<coord_t> & dimension () const throw()
         { return dim_; }
      deque<string> contenu () const
         { return deque<string>(fenetre_); }
      deque<string> contenu () const volatile
      {
         Autoverrou av (verrou_);
         return const_cast<const Zone *>(this)->contenu ();
      }
      template <class T>
         Zone & operator << (const T &val)
         {
            cur_.Ajouter (lexical_cast<string> (val));
            return *this;
         }
      template <class CType>
         Zone & operator << (const basic_string<CType> &val)
         {
            static const CType NL = use_facet<ctype<CType> >(locale ("")).widen ('\n');
            basic_string<CType>::size_type
               debut = 0, pos = val.find (NL);
            while (pos != basic_string<CType>::npos)
            {
               cur_.Ajouter (val.substr (debut, pos - debut));
               flush ();
               debut = pos + 1;
               pos = val.find (NL, debut);
            }
            cur_.Ajouter (val.substr (debut, pos));
            return *this;
         }
      void flush ()
      {
         string s = cur_.Extraire ();
         Autoverrou av (verrou_);
         fenetre_.push_back (s);
         if (fenetre_.size () > static_cast<string::size_type>(dimension ().hauteur ()))
            fenetre_.pop_front ();
      }
      Zone & operator << (std::ostream & (*pMutateur)(ostream &))
      {
         if (pMutateur == endl) flush ();
         return *this;
      }
      friend ostream & operator << (ostream &os, const Zone &z)
      {
         const vector<string>::size_type nLignes =
            static_cast<vector<string>::size_type>(z.dimension().hauteur ());
         deque<string> contenu = const_cast<const volatile Zone &>(z).contenu ();
         vector<string> v (contenu.begin (), contenu.end ());
         string s = z.cur_.Consulter ();
         if (!s.empty ()) v.push_back (s);
         while (v.size () < nLignes)
            v.push_back (string ());
         transform (v.begin (), v.end (), v.begin(),
                    creerFormateur (z.dimension().largeur(), ' '));
         os << creerBoite<char> (v);
         return os;
      }
   };


#endif

