#ifndef LEXICAL_CAST_H
#define LEXICAL_CAST_H

#include <string>
using std::basic_string;
using std::string;
#include <sstream>
using std::basic_stringstream;
using std::stringstream;

class implicite   {};
class texte_dest  {};
class texte_texte {};
class general     {};

#include "static_if_else.h"

template <class T, class U>
   struct meme_type
   {
      static const bool VAL = false;
   };
template <class T>
   struct meme_type<T,T>
   {
      static const bool VAL = true;
   };

#include "est_convertible.h"

template <class T>
   struct est_texte
   {
      static const bool VAL = false;
   };
template <class C>
   struct est_texte<basic_string<C> >
   {
      static const bool VAL = true;
   };

template <class D, class S>
   struct traits_conversion
   {
      typedef typename static_if_else<
         meme_type<D,S>::VAL || est_convertible<S, D>::VAL,
         implicite,
         typename static_if_else<
            est_texte<D>::VAL,
            typename static_if_else<
               est_texte<S>::VAL,
               texte_texte,
               texte_dest
            >::type,
            general
         >::type
      >::type type;
   };


template <class D, class S>
   D lexical_cast (const S &src, general)
   {
      stringstream sstr;
      sstr << src;
      D dest;
      sstr >> dest;
      return dest;
   }
template <class D, class S>
   D lexical_cast (const S &src, texte_dest)
   {
      typedef D::value_type value_type;
      basic_stringstream<value_type> sstr;
      sstr << src;
      return sstr.str();
   }
template <class D, class S>
   D lexical_cast (const S &src, texte_texte)
   {
      return D (src.begin (), src.end ());
   }
template <class D, class S>
   D lexical_cast (const S &src, implicite)
      { return src; }

template <class D, class S>
   D lexical_cast (const S &src)
   {
      return lexical_cast<D, S>(src, traits_conversion<D, S>::type());
   }

#endif