#ifndef LOCALE_HELPER_H
#define LOCALE_HELPER_H

#include <locale>
using std::ctype;
using std::locale;
using std::use_facet;

template <class CDest, class CSrc>
   CDest char_convert(const CSrc val, const locale &loc = locale(""))
      { return use_facet<ctype<CDest> >(locale("")).widen(val); }

#include <algorithm>
using std::transform;
#include <string>
using std::basic_string;
#include <iterator>
using std::back_inserter;

template <class CDest, class CSource>
   basic_string<CDest> convertir (const basic_string<CSource> &src, const locale &loc = locale(""))
   {
      struct convertisseur
      {
         const locale &loc_;
         convertisseur (const locale & loc) throw ()
            : loc_(loc)
         {
         }
         CDest operator () (const CSource c)
            { return use_facet<ctype<CDest> >(loc_).widen (c); }
      };
      basic_string<CDest> dest;
      transform (src.begin (), src.end (), back_inserter(dest), convertisseur(loc));
      return dest;
   }


#endif