#ifndef TYPE_LIST_H
#define TYPE_LIST_H

//
// Merci  Andrei Alexandrescu
//
class Vide {};

template <class T, class U>
   struct type_list
   {
      typedef T tete;
      typedef U queue;
   };

//
// Algorithmes statiques
//
template <class TList>
   struct longueur_liste;
template <class T, class Q>
   struct longueur_liste<type_list<T, Q> >
   {
      enum { VAL = 1 + longueur_liste<Q>::VAL };
   };
template <>
   struct longueur_liste<Vide>
   {
      enum { VAL = 0 };
   };


template <class TList, class T>
   struct position_dans_liste;
template <class T>
   struct position_dans_liste<Vide, T>
   {
      enum { VAL = -1 };
   };

template <class Queue, class T>
   struct position_dans_liste<type_list<T, Queue>, T>
   {
      enum { VAL = 0 };
   };

template <class Tete, class Queue, class T>
   struct position_dans_liste<type_list<Tete, Queue>, T>
   {
   private: // type priv, une sorte de temporaire
      enum
      {
         RechercheDansQueue = position_dans_liste<Queue, T>::VAL
      };
   public: // l'indice en tant que tel
      enum
      {
         VAL = RechercheDansQueue == -1? -1 : 1 + RechercheDansQueue
      };
   };

template <bool>
   struct static_assert;
template <>
   struct static_assert<true> {};

#endif
